import pygame, time, random, os, math
my_time = time
from pygame import *
import mappainter, isosprite, gui


global globex, globey
globex, globey = 0, 250

        
def load_image(name, colorkey=None):
    """loads an image into memory"""
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()


class Player(isosprite.Sprite):
    def __init__(self, globex, globey):
        isosprite.Sprite.__init__(self, globex, globey, None)
        self.isox = 10
        self.isoy = 10
        self.isoz = 0
        self.images, self.rects = load_image('needle-16dir.bmp', -1)
        self.image = pygame.Surface((50,50))
        self.rect = self.image.get_rect()
        self.split_images = []
        self.split_i()
        self.image = self.split_images[0]
        colorkey = self.image.get_at((0,0))
        self.image.set_colorkey(colorkey, RLEACCEL)

        self.facing = 0

    def split_i(self):
        ni = pygame.Surface((50,50))
        for i in range(16):
            ni.fill([0,0,0])
            ni.blit(self.images,(0,0),(i * 50,0,50,50))
            self.split_images.append(ni.copy())

    def move_forward(self, map_data):
        global globex, globey
        if self.facing == 1:
            self.facing = 0
        if self.facing == 2:
            self.facing = 3
        if self.facing == 4:
            self.facing = 3
        if self.facing == 5:
            self.facing = 6
        if self.facing == 9:
            self.facing = 8
        if self.facing == 10:
            self.facing = 11
        if self.facing == 12:
            self.facing = 11
        if self.facing == 13:
            self.facing = 14
        self.image = self.split_images[self.facing]
        colorkey = self.image.get_at((0,0))
        self.image.set_colorkey(colorkey, RLEACCEL)

        if self.facing == 0:
            globex += 8
            globey -= 4
            self.move_north(map_data)

        elif self.facing == 3:
            globey -= 4
            self.move_north_west(map_data)

        elif self.facing == 6:
            globex -= 8
            globey -= 4
            self.move_west(map_data)

        elif self.facing == 7:
            globex -= 8
            self.move_south_west(map_data)

        elif self.facing == 8:
            globex -= 8
            globey += 4
            self.move_south(map_data)

        elif self.facing == 11:
            globey += 4
            self.move_south_east(map_data)

        elif self.facing == 14:
            globex += 8
            globey += 4
            self.move_east(map_data)

        else:
            globex += 8
            self.move_north_east(map_data)

    def rotate(self, d):
        if d == "L":
            self.facing += 1
        else:
            self.facing -= 1

        if self.facing < 0:
            self.facing = 15
        elif self.facing > 15:
            self.facing = 0

        self.image = self.split_images[self.facing]
        colorkey = self.image.get_at((0,0))
        self.image.set_colorkey(colorkey, RLEACCEL)


class Herring(isosprite.Sprite):
    def __init__(self, globex, globey, locx, locy):
        isosprite.Sprite.__init__(self, globex, globey, None)
        self.isox = locx
        self.isoy = locy
        self.isoz = 0
        #self.isoz_offset = 15
        self.image, self.rect = load_image('prompt.bmp', -1)


class RedHerring(isosprite.Sprite):
    def __init__(self, globex, globey, locx, locy):
        isosprite.Sprite.__init__(self, globex, globey, None)
        self.isox = locx
        self.isoy = locy
        self.isoz = 0
        #self.isoz_offset = -15
        self.see_image, self.rect = load_image('enemy1.bmp', -1)
        self.inv_image, blah = load_image('enemy1.bmp', -1)
        self.image = self.see_image

        self.vis_counter = 0
        self.viewing_counter = 0
        self.viewing = True

        self.move_counter = 0
        self.goto = None

    def move(self):
        direction = []
        if self.goto == None:
            #determine another location
            self.goto = [random.randint(0,38), random.randint(0,38)]

        if self.goto[0] > self.isox:
            direction.append(1)
        elif self.goto[0] < self.isox:
            direction.append(-1)
        else:
            direction.append(0)

        if self.goto[1] > self.isoy:
            direction.append(1)
        elif self.goto[1] < self.isoy:
            direction.append(-1)
        else:
            direction.append(0)
            if self.goto[0] == self.isox:
                self.goto = None
            
        self.isox = self.isox + direction[0]
        self.isoy = self.isoy + direction[1]
        
    def update(self):
        self.move_counter += 1
        if self.move_counter == 20:
            self.move_counter = 0
            self.move()
        self.vis_counter += 1
        if self.vis_counter >= 30:
            self.image = self.see_image
        else:
            self.image = self.inv_image
            
        if self.vis_counter == 40:
            self.vis_counter = 0


class Sonar:
    def __init__(self):
        self.pos = (525, 100)
        self.radius = 100
        self.sweep = 50
        self.emit_from = None
        self.blips = []
        self.blip_colors = ( (255,0,0),#red
                             (0,255,0),#green
                             (0,0,255))#blue

        self.players = []
        self.enemies = []
        self.neuts = []
        self.enemy_blink = 0
        self.enemy_do_blink = 30
        self.blink_for = 4
        self.on_blinking = 0
        self.rotate = 0.0

    def draw(self, surf):
        self.rotate += 0.05
        if self.rotate >  2 * math.pi:
            self.rotate -= 2 * math.pi

        obj = pygame.Surface((200,200))
        obj.fill([0,0,0])
        obj.set_colorkey(obj.get_at((0,0)), RLEACCEL)
        obj.set_alpha(150)
        r = pygame.draw.circle(obj, (125,125,125), (100,100), self.radius, 0)
        r2 = obj.get_rect()
        r2.center = self.pos
        surf.blit(obj, r2)
        for blip in self.blips:
            if blip[0] == "r":
                if self.enemy_blink >= self.enemy_do_blink:
                    self.on_blinking += 1
                    if self.on_blinking >= self.blink_for:
                        self.on_blinking = 0
                        self.enemy_blink = 0
                    r = pygame.rect.Rect(self.pos[0] + (blip[1] - 2), self.pos[1] + (blip[2] - 2), 5,5)
                    pygame.draw.rect(surf, self.blip_colors[0], r, 1)
                else:
                    pass
            elif blip[0] == "g":
                r = pygame.rect.Rect(self.pos[0] + (blip[1] - 2), self.pos[1] + (blip[2] - 2), 5,5)
                pygame.draw.rect(surf, self.blip_colors[1], r, 1)
            else:
                r = pygame.rect.Rect(self.pos[0] + (blip[1] - 2), self.pos[1] + (blip[2] - 2), 5,5)
                pygame.draw.rect(surf, self.blip_colors[2], r, 1)
        posx = self.pos[0] - math.cos(self.rotate) * 100
        posy = self.pos[1] - math.sin(self.rotate) * 100
        pygame.draw.aaline(surf, [255,255,255], self.pos, (posx,posy), 1)

    def sweep_map(self):
        self.enemy_blink += 1
        self.blips = []
        if self.emit_from == None:
            for enemy in self.enemies:
                if enemy.isox <= self.sweep:
                    if enemy.isoy <= self.sweep:
                        self.blips.append(("r", enemy.isox, enemy.isoy))
                    else:
                        pass
                else:
                    pass
            for neut in self.neuts:
                if neut.isox <= self.sweep:
                    if neut.isoy <= self.sweep:
                        self.blips.append(("b", neut.isox, neut.isoy))
                    else:
                        pass
                else:
                    pass
            for player in self.players:
                if player.isox <= self.sweep:
                    if player.isoy <= self.sweep:
                        self.blips.append(("g", player.isox, player.isoy))

        else:
            for enemy in self.enemies:
                if enemy.isox >= self.emit_from[0] - self.sweep/2:
                    if enemy.isox <= self.emit_from[0] + self.sweep/2:
                        if enemy.isoy >= self.emit_from[1] - self.sweep/2:
                            if enemy.isoy <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("r",enemy.isox-self.emit_from[0],enemy.isoy-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass
            for neut in self.neuts:
                if neut.isox >= self.emit_from[0] - self.sweep/2:
                    if neut.isox <= self.emit_from[0] + self.sweep/2:
                        if neut.isoy >= self.emit_from[1] - self.sweep/2:
                            if neut.isoy <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("b",neut.isox-self.emit_from[0],neut.isoy-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass
            for player in self.players:
                if player.isox >= self.emit_from[0] - self.sweep/2:
                    if player.isox <= self.emit_from[0] + self.sweep/2:
                        if player.isoy >= self.emit_from[1] - self.sweep/2:
                            if player.isoy <= self.emit_from[1] + self.sweep/2:
                                self.blips.append(("g",player.isox-self.emit_from[0],player.isoy-self.emit_from[1]))
                            else:pass
                        else:pass
                    else:pass
                else:pass


    def sweep_from(self, loc):
        self.emit_from = loc

    def add_player(self, player):
        self.players.append(player)

    def add_enemy(self, enemy):
        self.enemies.append(enemy)

    def add_neut(self, neut):
        self.neuts.append(neut)

    def remove_player(self, player):
        self.players.remove(player)

    def remove_enemy(self, enemy):
        self.enemies.remove(enemy)

    def remove_neut(self, neut):
        self.neuts.remove(neut)

class Player_Timer:
    def __init__(self, duration):
        self.duration = duration
        self.finished = False
        self.cur_time = 0
        self.whirly = 0
        self.font = pygame.font.Font(None, 20)
        self.color = [0,0,0]
        self._lev = 0
        self._scr = 0

    def update(self, level, score):
        self._lev = level
        self._scr = score
        self.whirly += 1
        if self.whirly == 20:
            self.cur_time += 1
            self.whirly = 0
        if self.cur_time >= self.duration:
            self.finished = True
        """if self.cur_time >= 0:
            self.i.add_message("time left: %s"%(self.duration-self.cur_time))
            self.i.add_message("you are on level %s"%level)"""

    def draw(self, surf):
        mess = self.font.render("time left: %s"%(self.duration-self.cur_time),0,self.color)
        m2 = self.font.render("you are on level %s"%self._lev,0,self.color)
        m3 = self.font.render("score %s"%self._scr,0,self.color)
        surf.blit(mess, (25, 25))
        surf.blit(m2, (25, 50))
        surf.blit(m3, (25, 75))
        return


class game_states:
    def __init__(self):
        pygame.init()
        self.background_screen = pygame.display.set_mode((640,480), FULLSCREEN)
        pygame.display.set_caption("Search for the Red Herring - 0.1")
        self.clock = pygame.time.Clock()
        self.background_screen.fill([0,0,0])
        self.on_state = 'Play'
        self.player_score = 0
        self.level = 0

    def menu(self):
        pass

    def play(self):
        #game time!
        global globex, globey
        
        letters = "osmdw"#ocean floor, shallow, moderate, deep, whirlwind
        images = ['dirt.bmp',
                  'water_s.bmp',
                  'water_s.bmp',
                  'water_s.bmp',
                  'water_s.bmp']
        
        trans = [0,125,150,175,200]

        filename = 'map1.plm'
        ocean = mappainter.Isometric_Tile_Map(globex, globey, tile_size = 100, map_width = 40, map_height = 40)
        ocean.load_data(filename)
        ocean.load_tiles(letters, images, trans)

        game_timer = Player_Timer(20.0-self.level)
        
        p_sonar = Sonar()
        p = Player(globex, globey)
        p_sonar.add_player(p)

        p_rotating = [False, "L"]
        
        neut_group = []
        locs = []
        for x in range(40):
            for y in range(40):
                locs.append((x,y))
        
        for i in range(4):
            c = random.choice(locs)
            locs.remove(c)
            neut_group.append(Herring(globex, globey,c[0],c[1]))

        for i in neut_group:
            p_sonar.add_neut(i)

        c = random.choice(locs)
        locs.remove(c)
        enemy = RedHerring(globex, globey, c[0], c[1])
        p_sonar.add_enemy(enemy)

        exit_button = gui.Button(475, 400, 'button.bmp')

        moving_forward = False
        moving_backword = False

        while 1:
            self.clock.tick(20)

            #p_sonar.sweep_from(p)
            p_sonar.sweep_from((p.isox, p.isoy))
            p_sonar.sweep_map()
            #first draw the background
            self.background_screen.fill([0,155,255])
            ocean.draw_map(self.background_screen)

            #now draw units
            game_timer.draw(self.background_screen)
            p.draw(self.background_screen)
            for neut in neut_group:
                neut.draw(self.background_screen)
            enemy.draw(self.background_screen)
            exit_button.draw(self.background_screen, 'exit')
            p_sonar.draw(self.background_screen)
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                print "you quit"
                self.on_state = "Exit-Now"
                break

            for event in pygame.event.get():
                if event.type == KEYDOWN:
                    if event.key == K_UP:
                        if p.isoy > 0:
                            """p.isoy -= 1
                            globex += 50
                            globey -= 25"""
                            moving_forward = True
                    if event.key == K_DOWN:
                        if p.isoy < 39:
                            p.isoy += 1
                            globex -= 50
                            globey += 25

                    if event.key == K_LEFT:
                        """if p.isox > 0:
                            p.isox -= 1
                            globex -= 50
                            globey -= 25"""
                        p_rotating = [True, "L"]
                    if event.key == K_RIGHT:
                        """if p.isox < 39:
                            p.isox += 1
                            globex += 50
                            globey += 25"""
                        p_rotating = [True, "R"]
                if event.type == KEYUP:
                    if event.key == K_UP:
                        moving_forward = False
                    if event.key == K_DOWN:
                        moving_south = False
                    if event.key == K_LEFT:
                        p_rotating = [False, "L"]
                    if event.key == K_RIGHT:
                        p_rotating = [False, "R"]

            if moving_forward:
                global globex, globey
                p.move_forward(ocean.map_data)
                p.move_forward(ocean.map_data)
                ocean.move_globe(globex, globey)
            if p_rotating[0] == True:
                p.rotate(p_rotating[1])

            for neut in neut_group:
                if neut.isox == p.isox:
                    if neut.isoy == p.isoy:
                        neut_group.remove(neut)
                        self.player_score += 25
                        p_sonar.remove_neut(neut)

            if game_timer.finished:
                self.on_state = "End"
                break


            ocean.move_globe(globex,globey)
            p.globex, p.globey = globex, globey
            enemy.globex,enemy.globey = globex, globey
            for neut in neut_group:
                neut.globex, neut.globey = globex, globey

            enemy.update()
            game_timer.update(self.level, self.player_score)
            pygame.display.flip()
            pygame.event.pump()
            if p.isox == enemy.isox:
                if p.isoy == enemy.isoy:
                    self.on_state = "Play"
                    self.level += 1
                    globex, globey = 0,250
                    break

    def end(self):
        hello = gui.MessageBox(200, 75, 200, 50, 2)
        hello.add_message("Game Over!")
        scr = gui.MessageBox(200, 150, 200, 50, 2)
        scr.add_message("score: "+str(self.player_score))
        lev = gui.MessageBox(200, 225, 200, 50, 2)
        lev.add_message("level: "+str(self.level)) 
        self.background_screen.fill([0,0,0])
        exit_button = gui.Button(475, 400, 'button.bmp')

        while 1:
            self.background_screen.fill([0,0,0])
            m_d = gui.mouse_down(1)
            if exit_button.clicked(m_d) == True:
                print "you quit"
                self.on_state = "Exit-Now"
                break
            exit_button.draw(self.background_screen, 'EXIT')
            hello.draw(self.background_screen)
            scr.draw(self.background_screen)
            lev.draw(self.background_screen)
            pygame.display.flip()


game = game_states()
while 1:
    if game.on_state == 'Play':
        game.play()

    if game.on_state == 'End':
        game.end()

    if game.on_state == "Exit-Now":
        pygame.quit()
        break
