import pygame, os, random
from pygame import *


def load_image(name, colorkey=None):
    """loads an image into memory"""
    fullname = os.path.join('data', name)
    try:
        image = pygame.image.load(fullname)
    except pygame.error, message:
        print 'Cannot load image:', fullname
        raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if colorkey is -1:
            colorkey = image.get_at((0,0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image, image.get_rect()

class player:
    def __init__(self):
        self.images, self.rects = load_image('needle-16dir.bmp', -1)
        self.image = pygame.Surface((50,50))
        self.split_images = []
        self.split_i()
        self.rotation = -1

    def rotate(self):
        self.rotation += 1
        if self.rotation == 15:
            self.rotation = 0
        self.image = self.split_images[self.rotation]
        self.rect = self.image.get_rect()

    def split_i(self):
        ni = pygame.Surface((50,50))
        for i in range(16):
            ni.fill([0,0,0])
            ni.blit(self.images,(0,0),(i * 50,0,50,50))
            self.split_images.append(ni.copy())

pygame.init()
screen = pygame.display.set_mode((50,50))
clock = pygame.time.Clock()

p = player()
while p.rotation < 15:
    print p.rotation
    clock.tick(4)
    p.rotate()
    screen.blit(p.image, (0,0))
    pygame.display.flip()
